image: docker:19.03.1
services:
  - docker:19.03.1-dind

stages:
  - build
  - test
  - deploy

#######################################################
#                RELEASE branch                       #
#######################################################

#       BUILD
# --------------------

Create_Release_Latest_Docker_Image:
  stage: build
  only:
    - /^release-.*$/
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/release/build/docker_build.sh
    - sh ./.bash/release/build/docker_push.sh

#        TEST
# --------------------

Run_Release_Acceptance_Tests:
  stage: test
  only:
    - /^release-.*$/
  image: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-latest
  script:
    # - sh ./.bash/docker_login.sh
    # - sh ./.bash/release/docker_pull.sh
    - sh ./.bash/release/test/rel_accept_v2.sh
  artifacts:
    paths:
    - target
    expire_in: 1 week

#       DEPLOY
# --------------------

Create_Release_Stable_Docker_Image:
  stage: deploy
  only:
    - /^release-.*$/
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/release/docker_pull.sh
    - sh ./.bash/release/deploy/docker_tag.sh
    - sh ./.bash/release/deploy/docker_push.sh

#######################################################
#                FEATURE branch                       #
#######################################################

#       BUILD 
# --------------------

Create_Feature_Latest_Docker_Image:
  stage: build
  only:
    - /^feature-.*$/
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/feature/build/docker_build.sh
    - sh ./.bash/feature/build/docker_push.sh

#        TEST 
# --------------------

Run_Feature_Acceptance_Tests:
  stage: test
  only:
    - /^feature-.*$/
  image: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-latest
  script:
    # - sh ./.bash/docker_login.sh
    # - sh ./.bash/feature/docker_pull.sh
    - sh ./.bash/feature/test/ft_accept_v2.sh
  artifacts:
    paths:
    - target
    expire_in: 1 week

#       DEPLOY 
# --------------------

Create_Feature_Stable_Docker_Image:
  stage: deploy
  only:
    - /^feature-.*$/
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/feature/docker_pull.sh
    - sh ./.bash/feature/deploy/docker_tag.sh
    - sh ./.bash/feature/deploy/docker_push.sh

#######################################################
#                   ISSUE branch                      #
#######################################################

#       BUILD 
# --------------------

Create_Issue_Latest_Docker_Image:
  stage: build
  only:
    - /^issue-.*$/
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/issue/build/docker_build.sh
    - sh ./.bash/issue/build/docker_push.sh

#        TEST 
# --------------------

Run_Issue_Non_Regression_Tests:
  stage: test
  only:
    - /^issue-.*$/
  image: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-latest
  script:
    # - sh ./.bash/docker_login.sh
    # - sh ./.bash/issue/docker_pull.sh
    - sh ./.bash/issue/test/issue_nonreg_v2.sh
  artifacts:
    paths:
    - target
    expire_in: 1 week

#       DEPLOY 
# --------------------

Create_Issue_Stable_Docker_Image:
  stage: deploy
  only:
    - /^issue-.*$/
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/issue/docker_pull.sh
    - sh ./.bash/issue/deploy/docker_tag.sh
    - sh ./.bash/issue/deploy/docker_push.sh

#######################################################
#                  MASTER branch                      #
#######################################################

#       BUILD 
# --------------------

Create_Latest_Docker_Image:
  stage: build
  only:
    - master
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/master/build/docker_build.sh
    - sh ./.bash/master/build/docker_push.sh

#        TEST 
# --------------------

Run_Smoke_Tests:
  stage: test
  only:
    - master
  image: $CI_REGISTRY_IMAGE:latest
  script:
    # - sh ./.bash/docker_login.sh
    # - sh ./.bash/master/docker_pull.sh
    - sh ./.bash/master/test/smoke_v2.sh
    - ls /usr/app/target/cucumber-html-reports
  artifacts:
    paths:
    - /usr/app/target/cucumber-html-reports
    expire_in: 1 week

Run_All_Tests:
  stage: test
  only:
    - master
  image: $CI_REGISTRY_IMAGE:latest
  script:
    # - sh ./.bash/docker_login.sh
    # - sh ./.bash/master/docker_pull.sh
    - sh ./.bash/master/test/all_v2.sh
    - ls /usr/app/target/cucumber-html-reports
  artifacts:
    paths:
    - /usr/app/target/cucumber-html-reports
    expire_in: 1 week

#       DEPLOY 
# --------------------

Create_Stable_Docker_Image:
  stage: deploy
  only:
    - master
  script:
    - sh ./.bash/docker_login.sh
    - sh ./.bash/master/docker_pull.sh
    - sh ./.bash/master/deploy/docker_tag.sh
    - sh ./.bash/master/deploy/docker_push.sh